<?php
// Licensed under the GPL v2&

defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.controllerform');

class PoptinControllerPoptin extends JControllerForm
{
    public function save()
    {
        $jPost = JFactory::getApplication()->input;
        if (!$jPost->post->getString('poptin_user_id')) {
            return false;
        }
        $poptinUserId = $jPost->post->get('poptin_user_id');

        $res = PoptinData::updateData(array(
                'poptin_user_id' => "",
                'poptin_client_id' => $poptinUserId,
                'poptin_token' => "",
            ), $this);

        if ($res) {
            $this->setMessage("Poptin was successfully installed  on your site", 'success');
        }

        $this->setRedirect('index.php?option=' . $this->option);
        return $res;
    }


    public function delete()
    {
        $res = PoptinData::updateData(array(
            'poptin_user_id' => "",
            'poptin_client_id' => "",
            'poptin_token' => "",
        ), $this);

        if ($res) {
            $this->setMessage("Poptin was successfully removed from your site", 'success');
        }

        $this->setRedirect('index.php?option=' . $this->option);
        return $res;
    }

    public function create()
    {
        $jPost = JFactory::getApplication()->input;
        $email = $jPost->post->getString('email');
        if (empty($email)) return false;

        try {
            $response = PoptinApi::createAccount($email);

            if (!$response['success']) {
                $this->setMessage($response['message'], 'error');
            } else {
                PoptinData::updateData(array(
                    'poptin_user_id' => $response['user_id'],
                    'poptin_client_id' => $response['client_id'],
                    'poptin_token' => $response['token'],
                ), $this);

                $this->setMessage('Your account was successfully created', 'success');
            }
        } catch (Exception $exc) {
            $this->setMessage($exc->getMessage(), 'error');
        }

        $this->setRedirect('index.php?option=' . $this->option);
        return true;
    }

    public function redirectlogin()
    {
        $urlToRedirect = "https://app.popt.in";

        $params = JComponentHelper::getParams('com_poptin');
        $poptinUserId = $params->get('poptin_user_id');
        $poptinToken = $params->get('poptin_token');

        if (!empty($poptinUserId) && !empty($poptinToken)) {
            $apiResult = PoptinApi::authorizeAccount($poptinToken, $poptinUserId);
            if ($apiResult['success']) {
                $urlToRedirect = $apiResult['login_url'];
            }
        }
        $this->setRedirect($urlToRedirect);
    }
}
